unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  ExtCtrls, StdCtrls, ScktComp, IdUDPBase, IdUDPClient;

type
  TForm1 = class(TForm)
    IdTCPClient1: TIdTCPClient;
    Memo1: TMemo;
    Timer1: TTimer;
    Edit1: TEdit;
    Edit2: TEdit;
    Memo2: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const
  EOL = #13#10;
  Speed = 1000;

type
  TShaft = record
             Opened: Boolean;
             TargetLevels: array of Integer; {seznam cilu}
             CurrentLevel: Integer;
             Speed: Integer;
           end;

var
  Form1: TForm1;

  Shafts: array of TShaft;
  LevelHeight: Integer;
  FloorsNum: Integer;
  MaxAccel, MaxSpeed: Integer;


implementation

{$R *.dfm}

{vytahnuti casti retezce}
function GetNthPart(S: string; Delim: Char; Index: Integer): string;
var
  C1: Integer;
begin
  C1 := 1;
  while (C1 < Index) and (Pos(Delim, S) > 0) do
    begin
      C1 := C1 + 1;
      Delete(S, 1, Pos(Delim, S));
    end;
  if (Pos(Delim, S) = 0) then
    Result := S
  else
    Result := Copy(S, 1, Pos(Delim, S));

  Result := Trim(Result);
end;

{inicializace}
procedure TForm1.FormCreate(Sender: TObject);
begin
  IdTCPClient1.Port := {5438}StrToInt(Edit2.Text);
  IdTCPClient1.Host := {'127.0.0.1'}Edit1.Text;
  IdTCPClient1.Connect;

  IdTCPClient1.WriteLn('param');
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  Radka: string;
  Index, Num: Integer;
  C1, C2: Integer;
  NearestTarget: Integer;
begin
  if IdTCPClient1.Connected then
    begin
      {pokracovat s dalsimi zastavkami}
      for C1 := 0 to Length(Shafts) - 1 do
        {if (not Shafts[C1].Blocked) then}
          for C2 := 0 to Length(Shafts[C1].TargetLevels) - 1 do
            begin
              if (Shafts[C1].Opened) and (Shafts[C1].CurrentLevel <> Shafts[C1].TargetLevels[C2]) then
                begin
                  IdTCPClient1.WriteLn('close ' + IntToStr(C1));
                  Break;
                end;
              if (not Shafts[C1].Opened) and (Shafts[C1].CurrentLevel = Shafts[C1].TargetLevels[C2]) then
                begin
                  IdTCPClient1.WriteLn('open ' + IntToStr(C1));
                  Break;
                end;
            end;


      Radka := IdTCPClient1.ReadLn(EOL, 2000);

      {sbirani informaci}
      if (Pos('shafts ', Radka) = 1) then
        begin
          Num := StrToInt(GetNthPart(Radka, ' ', 2));
          SetLength(Shafts, Num);
          for C1 := 0 to Length(Shafts) - 1 do
            begin
              SetLength(Shafts[C1].TargetLevels, 0);
              Shafts[C1].CurrentLevel := 0;
              Shafts[C1].Speed := 0;
            end;
        end;
      if (Pos('maxaccel ', Radka) = 1) then
        begin
          Num := StrToInt(GetNthPart(Radka, ' ', 2));
          MaxAccel := Num;
        end;
      if (Pos('maxspeed ', Radka) = 1) then
        begin
          Num := StrToInt(GetNthPart(Radka, ' ', 2));
          MaxSpeed := Num;
        end;
      if (Pos('levels ', Radka) = 1) then
        begin
          Num := StrToInt(GetNthPart(Radka, ' ', 2));
          FloorsNum := Num;
        end;
      if (Pos('levelheight ', Radka) = 1) then
        begin
          Num := StrToInt(GetNthPart(Radka, ' ', 2));
          LevelHeight := Num;
        end;


      {osetreni chybovych stavu}
      if (Pos('error ', Radka) = 1) then
        begin
          Index := StrToInt(GetNthPart(Radka, ' ', 2));
          Num := StrToInt(GetNthPart(Radka, ' ', 3));
          {narovnat}
          if (Num = 5) then
            IdTCPClient1.WriteLn('floor ' + IntToStr(Index) + ' ' + IntToStr(Shafts[Index].CurrentLevel));
        end;


      {po zastaveni otevrit}
      if (Pos('speed ', Radka) = 1) then
        begin
          Index := StrToInt(GetNthPart(Radka, ' ', 2));
          Num := StrToInt(GetNthPart(Radka, ' ', 3));

          NearestTarget := Shafts[Index].TargetLevels[0];
          for C1 := 1 to Length(Shafts[Index].TargetLevels) - 1 do
            if (  Abs(Shafts[Index].CurrentLevel - Shafts[Index].TargetLevels[C1])
                < Abs(Shafts[Index].CurrentLevel - Shafts[Index].TargetLevels[NearestTarget])) then
              NearestTarget := C1;

{          if (Num > 0) then
            begin
              if (Abs(Num + MaxAccel) <= MaxSpeed) then
                IdTCPClient1.WriteLn('speed ' + IntToStr(Index) + ' ' + IntToStr(Num + MaxAccel));
            end
          else
            begin
              if (Abs(Num - MaxAccel) <= MaxSpeed) then
                IdTCPClient1.WriteLn('speed ' + IntToStr(Index) + ' ' + IntToStr(Num - MaxAccel));
            end;{}


          Shafts[Index].Speed := Num;

          if (Num = 0) then
            IdTCPClient1.WriteLn('open ' + IntToStr(Index));
        end;

      {prujezd patrem}
      if (Pos('level ', Radka) = 1) then
        begin
          Index := StrToInt(GetNthPart(Radka, ' ', 2));
          Num := StrToInt(GetNthPart(Radka, ' ', 3));
          Shafts[Index].CurrentLevel := Num;

{}          for C1 := 0 to Length(Shafts[Index].TargetLevels) - 1 do
            if (Num = Shafts[Index].TargetLevels[C1]) then
              begin
                IdTCPClient1.WriteLn('indiupoff ' + IntToStr(Shafts[Index].TargetLevels[C1]));
                IdTCPClient1.WriteLn('indidnoff ' + IntToStr(Shafts[Index].TargetLevels[C1]));
                IdTCPClient1.WriteLn('indioff ' + IntToStr(Index) + ' ' + IntToStr(Shafts[Index].TargetLevels[C1]));
                IdTCPClient1.WriteLn('speed ' + IntToStr(Index) + ' ' + IntToStr(0));
                {narovnat}
                IdTCPClient1.WriteLn('floor ' + IntToStr(Index) + ' ' + IntToStr(Num));
                IdTCPClient1.WriteLn('open ' + IntToStr(Index));

                {odstranit ze seznamu cilu}
{                for C2 := C1 to Length(Shafts[Index].TargetLevels) - 2 do
                  Shafts[Index].TargetLevels[C2] := Shafts[Index].TargetLevels[C2 + 1];
                SetLength(Shafts[Index].TargetLevels, Length(Shafts[Index].TargetLevels) - 1);

                Break;}
              end;{}
        end;


      {pohyb, zastavovani}
      if (Pos('meter ', Radka) = 1) then
        begin
          Index := StrToInt(GetNthPart(Radka, ' ', 2));
          Num := StrToInt(GetNthPart(Radka, ' ', 3));

          for C1 := 0 to Length(Shafts[Index].TargetLevels) - 1 do
            if  (Num > (FloorsNum - 1 - Shafts[Index].TargetLevels[C1]) * LevelHeight - 1000)
            and (Num < (FloorsNum - 1 - Shafts[Index].TargetLevels[C1]) * LevelHeight + 1000) then
              begin
                IdTCPClient1.WriteLn('indiupoff ' + IntToStr(Shafts[Index].TargetLevels[C1]));
                IdTCPClient1.WriteLn('indidnoff ' + IntToStr(Shafts[Index].TargetLevels[C1]));
                IdTCPClient1.WriteLn('indioff ' + IntToStr(Index) + ' ' + IntToStr(Shafts[Index].TargetLevels[C1]));
                IdTCPClient1.WriteLn('speed ' + IntToStr(Index) + ' ' + IntToStr(0));
                IdTCPClient1.WriteLn('open ' + IntToStr(Index));

                {odstranit ze seznamu cilu}
                for C2 := C1 to Length(Shafts[Index].TargetLevels) - 2 do
                  Shafts[Index].TargetLevels[C2] := Shafts[Index].TargetLevels[C2 + 1];
                SetLength(Shafts[Index].TargetLevels, Length(Shafts[Index].TargetLevels) - 1);

                Break;
              end;
        end;


      {zavreni dveri, rozjezd}
      if (Pos('closed ', Radka) = 1) then
        begin
          Index := StrToInt(GetNthPart(Radka, ' ', 2));
          Shafts[Index].Opened := False;

          for C1 := 0 to Length(Shafts[Index].TargetLevels) - 1 do
            if (Shafts[Index].CurrentLevel < Shafts[Index].TargetLevels[C1]) then
              IdTCPClient1.WriteLn('speed ' + IntToStr(Index) + ' ' + IntToStr(-{}Speed{}{MaxAccel{}))
            else if (Shafts[Index].CurrentLevel > Shafts[Index].TargetLevels[C1]) then
              IdTCPClient1.WriteLn('speed ' + IntToStr(Index) + ' ' + IntToStr({}Speed{}{MaxAccel{}))
            else
              IdTCPClient1.WriteLn('speed ' + IntToStr(Index) + ' ' + IntToStr(0));

        end;



      if (Pos('opened ', Radka) = 1) then
        begin
          Index := StrToInt(GetNthPart(Radka, ' ', 2));
          Shafts[Index].Opened := True;
        end;


      {objednavka vytahu}
      if (Pos('levelbuttonup ', Radka) = 1) then
        begin
          Index := 0;
          for C1 := 0 to Length(Shafts) - 1 do
            if (Shafts[C1].Speed = 0) then
              begin
                Index := C1;
                Break;
              end;

          Num := StrToInt(GetNthPart(Radka, ' ', 2));

          {pridani cile}
          SetLength(Shafts[Index].TargetLevels, Length(Shafts[Index].TargetLevels) + 1);
          Shafts[Index].TargetLevels[Length(Shafts[Index].TargetLevels) - 1] := Num;

          IdTCPClient1.WriteLn('indiupon ' + IntToStr(Num));

          IdTCPClient1.WriteLn('close ' + IntToStr(Index));
        end;



      {objednavka vytahu}
      if (Pos('levelbuttondn ', Radka) = 1) then
        begin
          Index := 0;
          for C1 := 0 to Length(Shafts) - 1 do
            if (Shafts[C1].Speed = 0) then
              begin
                Index := C1;
                Break;
              end;

          Num := StrToInt(GetNthPart(Radka, ' ', 2));

          {pridani cile}
          SetLength(Shafts[Index].TargetLevels, Length(Shafts[Index].TargetLevels) + 1);
          Shafts[Index].TargetLevels[Length(Shafts[Index].TargetLevels) - 1] := Num;

          IdTCPClient1.WriteLn('indidnon ' + IntToStr(Num));

          IdTCPClient1.WriteLn('close ' + IntToStr(Index));
        end;



      {urceni cile z kabiny}
      if (Pos('cabinbutton ', Radka) = 1) then
        begin
          Index := StrToInt(GetNthPart(Radka, ' ', 2));
          Num := StrToInt(GetNthPart(Radka, ' ', 3));

          {pridani cile}
          SetLength(Shafts[Index].TargetLevels, Length(Shafts[Index].TargetLevels) + 1);
          Shafts[Index].TargetLevels[Length(Shafts[Index].TargetLevels) - 1] := Num;

          IdTCPClient1.WriteLn('indion ' + IntToStr(Index) + ' ' + IntToStr(Num));

          IdTCPClient1.WriteLn('close ' + IntToStr(Index));
        end;

      if (Trim(Radka) <> '') then
        Memo1.Lines.Add(Radka);
    end;

end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  IdTCPClient1.Disconnect;
end;

end.
